﻿var _svgHeight;
var _svgWidth;
var canvasObject;
var diagram;
var rowCount;
var columnCount;
var width;
var height;
var savecanvas;
function print() {
    this._getSize();
    var div1 = document.createElement("div");
    div1.setAttribute("id", "print");
    div1.setAttribute("style", "display:none");
    document.body.appendChild(div1);
    var imgcollection = new Array();
    var _svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
    _svg.setAttribute("id", "print_svg");
    _svg.setAttribute("style", "height:" + this._svgHeight + "; width:" + this._svgWidth + ";");
    _svg.setAttribute("version", "1.1");
    _svg.setAttribute("xlink", "http://www.w3.org/1999/xlink");
    div1.appendChild(_svg);

    var _printg = document.getElementById("DiagramContent_canvas_diagramLayer").cloneNode(true);
    _svg.appendChild(_printg);

    this._createCanvas(width, height);
    var qUrl = this._initCanvas('url');
    if (qUrl != null && qUrl != '') {
        r();
        canvg('canvas', qUrl);
    }
    var qSvg = this._initCanvas('svg');
    if (qSvg != null && qSvg != '') {
        r();
        canvg('canvas', qSvg);
    }
    for (var i = 0; i < rowCount; i++) {
        for (var j = 0; j < columnCount; j++) {
            this._createCanvas(width, height);
            var canvas = document.getElementById("print_canvas");
            this._svgToCanvas(div1, canvas, width * j, height * i, width, height);
            var img = this.saveAsPNG(canvas, true, width * j, height * i, width, height);
            imgcollection.push(img);
        }
    }
    var div = document.createElement("div");
    for (var p = 0; p < imgcollection.length; p++) {
        div.appendChild(imgcollection[p]);
    }
    this._getprintwin(div);
};

function exportTo(type) {

    var imgData = "", imgType = "";
    this._getSize();
    var div1 = document.createElement("div");
    div1.setAttribute("id", "export");
    div1.setAttribute("style", "display:none");
    document.body.appendChild(div1);
    var imgcollection = new Array();
    var _svg = document.createElementNS("http://www.w3.org/2000/svg", "svg");
    if (ej.browserInfo().name !== "msie") {
        _svg.setAttribute("xmlns", "http://www.w3.org/2000/svg");
    }
    _svg.setAttribute("id", "export_svg");
    _svg.setAttribute("style", "height:" + this._svgHeight + "; width:" + this._svgWidth + ";");
    _svg.setAttribute("version", "1.1");
    _svg.setAttribute("xlink", "http://www.w3.org/1999/xlink");
    div1.appendChild(_svg);
    var _tags = document.getElementById("DiagramContent_canvaspatterndefinition").cloneNode(true);
    var _printg = document.getElementById("DiagramContent_canvas_diagramLayer").cloneNode(true);
    _svg.appendChild(_printg);
    
    var _defs = document.getElementById("DiagramContent_canvaspatterndefinition").cloneNode(true);
    _defs.removeChild(_defs.firstChild);
    _svg.appendChild(_defs);

    var drawText = div1.innerHTML;
    //this.initExport();
    // var canvas = document.getElementById("print_canvas");
    switch (type.toString()) {
        case "png":

            this._svgToCanvas(div1, canvas, 0, 0, this._svgWidth, this._svgHeight);
            imgData = this.saveAsPNG(canvas, false, 0, 0, this._svgWidth, this._svgHeight);
            imgType = "png";
            break;
        case "bmp":

            this._svgToCanvas(div1, canvas, 0, 0, this._svgWidth, this._svgHeight);
            imgData = this.saveAsBMP(canvas, false, 0, 0, this._svgWidth, this._svgHeight);
            imgType = "bmp";
            break;
        case "jpg":

            this._svgToCanvas(div1, canvas, 0, 0, this._svgWidth, this._svgHeight);
            imgData = this.saveAsJPEG(canvas, false, 0, 0, this._svgWidth, this._svgHeight);
            imgType = "jpg";
            break;
        case "svg":
            var value = this.saveAsSVG(div1);
            imgData = value;
            imgType = "svg";
    }
    this.exportAction(imgData, imgType);
}

function exportAction(imgData, imgType) {


    if (imgType == "svg") {

        var blob = new Blob([imgData], { type: "text/plain;charset=utf-8" });
        saveAs(blob, "diagram.svg");
    }
    else if (imgType == "png") {
        var canvas = savecanvas, ctx = canvas.getContext("2d");
        canvas.toBlob(function (blob) {
            saveAs(blob, "diagram.png");
        });
    }
    else if (imgType == "jpg") {
        var canvas = savecanvas, ctx = canvas.getContext("2d");
        canvas.toBlob(function (blob) {
            saveAs(blob, "diagram.jpg");
        });
    }
    else if (imgType == "bmp") {
        var canvas = savecanvas, ctx = canvas.getContext("2d");
        canvas.toBlob(function (blob) {
            saveAs(blob, "diagram.bmp");
        });
    }
}

function saveAsSVG(div) {
    return div.innerHTML;
}
function initExport() {
    this._createCanvas(this._svgWidth, this._svgHeight);
    var qUrl = this._initCanvas('url');
    if (qUrl != null && qUrl != '') {
        r();
        canvg('canvas', qUrl);
    }
    var qSvg = this._initCanvas('svg');
    if (qSvg != null && qSvg != '') {
        r();
        canvg('canvas', qSvg);
    }

    this.bHasDataURL = !!(this.canvasObject.toDataURL);
    this.bHasImageData = !!(this.canvasObject.getContext("2d").getImageData);
    if (!window.btoa) window.btoa = base64.encode
    if (!window.atob) window.atob = base64.decode
    this.bHasBase64 = !!(window.btoa);
    strDownloadMime = "image/octet-stream";
}

function _getSize() {
    diagram = $("#DiagramContent").ejDiagram("instance");
    var svg = document.getElementById("DiagramContent_canvas_svg");
    var w = $(svg).width();
    var h = $(svg).height();
    //var bounds = diagram.getBounds();
    //if (diagram.model.pageSettings.pageWidth != 0) {
    //    width = diagram.model.pageSettings.pageWidth;
    //    columnCount = this._calculatecolumns(bounds.width, width);
    //}
    //else {
    //    width = bounds.width;
    //    columnCount = 1;
    //}

    //if (diagram.model.pageSettings.pageHeight != 0) {
    //    height = diagram.model.pageSettings.pageHeight;
    //    rowCount = this._calculaterows(bounds.height, height);
    //}
    //else {
    //    height = bounds.height;
    //    rowCount = 1;
    //}

    //var _svg = document.getElementById("diagram_canvas_svg");
    _svgWidth = w;
    _svgHeight = h;

    var Size = new ej.datavisualization.Diagram.Point(this._svgWidth, this._svgHeight);
    return Size;
}

function _calculatecolumns(comparewidth, width) {
    return parseInt(Math.ceil(comparewidth / width));
}

function _calculaterows(compareheight, height) {
    return parseInt(Math.ceil(compareheight / height));
}

function _getprintwin(div) {
    var PrintWind = window.open('');
    PrintWind.document.write('<html><head><title> ej.Diagram</title></head>');
    PrintWind.document.write('<BODY onload="window.print()">');
    PrintWind.document.write('<center>');
    PrintWind.document.write(div.innerHTML + "</center>");
    PrintWind.document.close();
}

function _svgToCanvas(div, canvas, ix, iy, width, height) {
    canvg(canvas, div.innerHTML, {
        ignoreMouse: true,
        ignoreAnimation: true,
        ignoreDimensions: true,
        ignoreClear: true,
        offsetX: -ix,
        offsetY: -iy,
        scaleWidth: width,
        scaleHeight: height
    });
}

function _initCanvas(k) {
    var qs = window.location.search.substring(1);
    var t = qs.split("&");
    for (i = 0; i < t.length; i++) {
        kv = t[i].split("=");
        if (kv[0] == k) return unescape(kv[1]).replace('+', ' ');
    }
    return null;
}

function _createCanvas(width, height) {
    var check = document.getElementById("print_extradiv");
    if (check != null) {
        $("#print_extradiv").remove();

    }
    var element = document.createElement("div");
    element.setAttribute("id", "print_extradiv");
    element.setAttribute("style", "display:none");
    var canvas = document.createElement("canvas");
    canvas.setAttribute("id", "print_canvas");
    canvas.setAttribute("width", width + "px");
    canvas.setAttribute("height", height + "px");
    canvas.setAttribute("style", "height:" + height + "; width:" + width + "; display:none");
    document.body.appendChild(element);
    element.appendChild(canvas);
    this.canvasObject = canvas;

    this.bHasDataURL = !!(this.canvasObject.toDataURL);
    this.bHasImageData = !!(this.canvasObject.getContext("2d").getImageData);
    if (!window.btoa) window.btoa = base64.encode
    if (!window.atob) window.atob = base64.decode
    this.bHasBase64 = !!(window.btoa);
    strDownloadMime = "image/octet-stream";
}

function saveAsPNG(oCanvas, bReturnImg, ix, iy, iWidth, iHeight) {
    if (!this.bHasDataURL) {
        return false;
    }
    var oScaledCanvas = this._scaleCanvas(oCanvas, ix, iy, iWidth, iHeight);
    savecanvas = oScaledCanvas;
    var strData = oScaledCanvas.toDataURL("image/png");
    if (bReturnImg) {
        return this._makeImageObject(strData);
    } else {
        return strData.replace("image/png", strDownloadMime);
    }
    return true;
}

function saveAsBMP(oCanvas, bReturnImg, ix, iy, iWidth, iHeight) {
    if (!(this.bHasImageData && this.bHasBase64)) {
        return false;
    }
    var oScaledCanvas = this._scaleCanvas(oCanvas, ix, iy, iWidth, iHeight);
    savecanvas = oScaledCanvas;
    var strMime = "image/png";
    var strData = oScaledCanvas.toDataURL(strMime);

    if (bReturnImg) {
        return this._makeImageObject(strData);
    } else {
        return strData.replace(strMime, strDownloadMime);
    }
    return true;
}

function saveAsJPEG(oCanvas, bReturnImg, ix, iy, iWidth, iHeight) {
    if (!this.bHasDataURL) {
        return false;
    }

    var oScaledCanvas = this._scaleCanvas(oCanvas, ix, iy, iWidth, iHeight);
    savecanvas = oScaledCanvas;
    var strMime = "image/jpeg";
    var strData = oScaledCanvas.toDataURL(strMime);

    // check if browser actually supports jpeg by looking for the mime type in the data uri.
    // if not, return false
    if (strData.indexOf(strMime) != 5) {
        return false;
    }

    if (bReturnImg) {
        return this._makeImageObject(strData);
    } else {
        return strData.replace(strMime, strDownloadMime);
    }
    return true;
}

function _makeImageObject(strSource) {
    var oImgElement = document.createElement("img");
    oImgElement.src = strSource;
    return oImgElement;
}

function _scaleCanvas(oCanvas, ix, iy, iWidth, iHeight) {
    if (iWidth && iHeight) {
        var oSaveCanvas = document.createElement("canvas");
        oSaveCanvas.width = iWidth;
        oSaveCanvas.height = iHeight;
        oSaveCanvas.style.width = iWidth + "px";
        oSaveCanvas.style.height = iHeight + "px";

        var oSaveCtx = oSaveCanvas.getContext("2d");
        oSaveCtx.fillStyle = diagram.model.pageSettings.pagebackgroundColor;
        oSaveCtx.fillRect(0, 0, iWidth, iHeight)
        oSaveCtx.drawImage(oCanvas, 0, 0, iWidth, iHeight, 0, 0, iWidth, iHeight);
        return oSaveCanvas;
    }
    return oCanvas;
}