﻿/// <reference path="knockout-min.js" />
var DiagramPin = false;
this.selectedConnectorItem = [];
this.selectedNodeItem = [];

function SetLabelSizeAndFamilyToDropDown(args) {
    if (args != null) {
        if (args == "fontsizediffer") {
            {
                $('#fontsizelist').ejDropDownList("option", "value", "");
            }
        }
        else {
            if (args.fontSize >= 8) {
                $("#fontsizelist").ejDropDownList("option", { selectedItemIndex: args.fontSize - 8 });
            }
            else {
                $("#fontsizelist").ejDropDownList({ selectedTo: null });
            }
        }
        if (args == "fontFamilydiffer") {
            $('#fontStylelist').ejDropDownList("option", "value", "");
        }
        else {
            if (args.fontFamily == "Arial") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 0 });
            }
            else if (args.fontFamily == "Aharoni") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 1 });
            }
            else if (args.fontFamily == "Bell MT") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 2 });
            }
            else if (args.fontFamily == "Fantasy") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 3 });
            }
            else if (args.fontFamily == "Times New Roman") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 4 });
            }
            else if (args.fontFamily == "Segoe UI") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 5 });
            }
            else if (args.fontFamily == "Verdana") {
                $("#fontStylelist").ejDropDownList("option", { selectedItemIndex: 6 });
            }
        }
    }
    else if (args == null || args == undefined) {
        DisableState("fontsizelist");
        DisableState("fontStylelist");
    }
}

function setNodeSizeAndDimensionsToNumericTextbox(item, prop) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    var aspectratio = $('#aspectratioCheckBox').ejCheckBox("instance");
    $('#aspectratioCheckBox').ejCheckBox({ checked: (item.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) ? true : false });
    diagram._selectedObject.dimensionsChanged = false;
    if (prop == undefined) {
        $("#widthnumeric").ejNumericTextbox({ value: item.width });
        $("#heightnumeric").ejNumericTextbox({ value: item.height });
        $("#offsetxnumeric").ejNumericTextbox({ value: item.offsetX });
        $("#offsetynumeric").ejNumericTextbox({ value: item.offsetY });
    }
    else if (prop == "size") {
        $("#widthnumeric").ejNumericTextbox({ value: item.width });
        $("#heightnumeric").ejNumericTextbox({ value: item.height });
    }
    else if (prop == "offset") {
        $("#offsetxnumeric").ejNumericTextbox({ value: item.offsetX });
        $("#offsetynumeric").ejNumericTextbox({ value: item.offsetY });
    }
}
function setOpacityToSlider(item) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    $("#opacity").ejSlider({ value: item.opacity * 100 });

}
function setNodeSizeAndDimensionsToNode(args, prop) {

    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (diagram._selectedObject == undefined) {
        diagram._selectedObject = new SelectorVMClass();
    }
    diagram._selectedObject.method(args, prop);
}

function MouseEnterOnColorPalette(args) {
    document.getElementById(args.id).style.width = "26px";
    document.getElementById(args.id).style.height = "26px";
    document.getElementById(args.id).style.border = "3px solid";
    document.getElementById(args.id).style.borderColor = "#3A3A3A";

}

function MouseLeaveOnColorPalette(args) {
    document.getElementById(args.id).style.width = "30px";
    document.getElementById(args.id).style.height = "30px";
    document.getElementById(args.id).style.border = "1px solid";
    document.getElementById(args.id).style.borderColor = "#3A3A3A";
}
function MouseEnterOnDiv(args, prop, fontclass) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram._selectedObject.mouseenter(args, prop, true);
}

function MouseLeaveFromDiv(args, prop, fontclass) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram._selectedObject.mouseenter(args, prop, false);
}

function tabItemChanged(args, tab) {
    //  
    var diagram = $("#DiagramContent").ejDiagram("instance");
    if (diagram._selectedObject != undefined) {
        ko.applyBindings(diagram._selectedObject.setTabIconColor(args, tab));
    }
}

function dropdownOpened(args) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram._selectedObject.setPopupDivColor(args, diagram._selectedObject, true);
}

function dropdownClosed(args) {
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram._selectedObject.setPopupDivColor(args, diagram._selectedObject, false);
}

function setThickness(args, dropDownId) {

    if (args != null) {
        if (args.shape)
            $("#" + dropDownId).ejDropDownList("option", { selectedItemIndex: Math.round(args.borderWidth - 1) });
        else
            $("#" + dropDownId).ejDropDownList("option", { selectedItemIndex: Math.round(args.lineWidth - 1) });
    }
    else {
        $("#" + dropDownId).ejDropDownList("option", "value", "");
    }
}

function setSourceOrTargetDecoratortoPanel(args) {
    if (args != null) {
        if (args.segments) {
            var ssss = "headDecorator";
            if (args.sourceDecorator == null) {
                $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 0 });
            }
            else if (args.sourceDecorator.shape == "arrow") {
                if (args.sourceDecorator.fillColor == "white")
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 5 });
                else
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 1 });
            }
            else if (args.sourceDecorator.shape == "diamond") {
                if (args.sourceDecorator.fillColor == "white")
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 6 });
                else
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 2 });
            }
            else if (args.sourceDecorator.shape == "circle") {
                if (args.sourceDecorator.fillColor == "white")
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 7 });
                else
                    $("#headDecorator").ejDropDownList("option", { selectedItemIndex: 3 });
            }

            if (args.targetDecorator == null) {
                $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 0 });
            }
            else if (args.targetDecorator.shape == "arrow") {
                if (args.targetDecorator.fillColor == "white")
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 5 });
                else
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 1 });
            }
            else if (args.targetDecorator.shape == "diamond") {
                if (args.targetDecorator.fillColor == "white")
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 6 });
                else
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 2 });
            }
            else if (args.targetDecorator.shape == "circle") {
                if (args.targetDecorator.fillColor == "white")
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 7 });
                else
                    $("#tailDecorator").ejDropDownList("option", { selectedItemIndex: 3 });
            }
        }
        else
            $("#" + dropDownId).ejDropDownList("option", { selectedItemIndex: args.lineWidth - 1 });
    }
    else {
        $("#" + dropDownId).ejDropDownList("option", "value", "");
    }
}

function PropertyChangesFromPanel(args, prop) {
    args.down = true;
    var diagram = $("#DiagramContent").ejDiagram("instance");
    diagram._modified = true;
    ko.applyBindings(diagram._selectedObject.method(args, prop));
}

var SelectorVMClass = (function () {

    function SelectorVMClass() {
        this.fillColor = null;
        this.opacity = 100;
        this.fillDivColor = ko.observable("#F9F9F9");
        this.fillCornerColor = ko.observable("#A3A2A2");
        this.width = ko.observable(null);
        this.height = ko.observable(null);
        this.offsetX = ko.observable(null);
        this.offsetY = ko.observable(null);
        this.aspectRatio = null;
        this.stroke = null;
        this.strokeDivColor = "#F9F9F9";
        this.strokeCornerColor = "#A3A2A2";
        this.strokePenColor = "7F7F7F";
        this.borderthickness = null;
        this.borderthicknessfontColor = "7F7F7F";
        this.borderthicknessDivColor = "#F9F9F9";
        this.borderthicknessCornerColor = "#A3A2A2";;
        this.gradient = false;
        this.gradientDivColor = "#F9F9F9";
        this.gradientfontColor = null;
        this.label = false;
        this.labelfontSize = 0;
        this.labelfontColor = null;
        this.fontColorDiv = "#F9F9F9";
        this.labelfontFamily = null;
        this.textAlign = null;
        this.fontCornerColor = "#A3A2A2";;
        this.bold = false;
        this.boldDivColor = "#F9F9F9";
        this.boldfontColor = "#7F7F7F";
        this.italic = null;
        this.italicDivColor = "#F9F9F9";
        this.italicfontColor = "#7F7F7F";
        this.lineColor = null;
        this.lineDivColor = "#F9F9F9";
        this.lineColorCorner = "#A3A2A2";
        this.lineWidth = null;
        this.lineWidthDivColor = "#F9F9F9";
        this.lineWidthfontColor = null;
        this.lineWidthCornerColor = "#A3A2A2";
        this.headDecorator = null;
        this.headDecoratorDivColor = "#F9F9F9";
        this.headDecoratorfontColor = null;
        this.headDecoratorCornerColor = "#A3A2A2";;
        this.tailDecorator = null;
        this.tailDecoratorDivColor = "#F9F9F9";
        this.tailDecoratorfontColor = null;
        this.tailDecoratorCornerColor = "#A3A2A2";
        this.line = null;
        this.lineconnectorfontColor = null;
        this.lineconnectorDivColor = "#F9F9F9";
        this.lineconnectorCornerColor = "#A3A2A2";
        this.lock = null;
        this.lockConstrains = {};
        this.lockfontColor = "#7F7F7F";
        this.lockDivColor = "#F9F9F9";
        this.lineStylefontColor = "#7F7F7F";
        this.lineStyleCornerColor = "#A3A2A2";
        this.lineStyleDivColor = "#F9F9F9";
        this.offsetXDsiabled = null;
        this.textLeftAlign = false;
        this.textLeftAlignfont = "#7F7F7F";
        this.textLeftAlignDiv = "#F9F9F9";
        this.textRightAlign = false;
        this.textRightAlignfont = "#7F7F7F";
        this.textRightAlignDiv = "#F9F9F9";
        this.textCenterAlign = false;
        this.textCenterAlignfont = "#7F7F7F";
        this.textCenterAlignDiv = "#F9F9F9";
        this.dimensionsChanged = false;
        this.selectedItem = [];
        this.selectedConnectorItem = [];
        this.selectedNodeItem = [];

        this.tabPinIcon = "#999999";
        this.tabnodeicon = "#999999";
        this.tabTextIcon = "#999999";
        this.tabConnectorIcon = "#999999";
        this.pinned = false;
        this.dropdownOpened = false;
        this.init = 0;
    }

    SelectorVMClass.prototype.select = function () {
        var diagram = $("#DiagramContent").ejDiagram("instance");
        var aspectratio = $('#aspectratioCheckBox').ejCheckBox("instance");
        if (diagram.selectionList.length > 0) {
            var item = diagram.selectionList[0];
            this.dimensionsChanged = false;
            while (selectedNodeItem.length > 0) {
                selectedNodeItem.pop();
            }

            while (selectedConnectorItem.length > 0) {
                selectedConnectorItem.pop();
            }
            if (diagram.selectionList[0].isGroup && !(diagram.selectionList[0].isPseudoGroup)) {
                this.fillColor = "#DDDBDB";
                this.fillDivColor = "#F2F2F2";
                this.fillCornerColor = "#F2F2F2";
                this.opacity = item.opacity * 100;
                DisableState("fillColor");

                this.stroke = "#DDDBDB";
                this.strokeDivColor = "#F2F2F2";
                this.strokeCornerColor = "#F2F2F2";
                this.strokePenColor = "#DDDBDB";
                DisableState("stroke");

                this.borderthickness = null;
                this.borderthicknessfontColor = "#DDDBDB";
                this.borderthicknessDivColor = "#F2F2F2";
                this.borderthicknessCornerColor = "#F2F2F2";
                DisableState("borderWidth");


                this.gradientfontColor = "#DDDBDB";
                this.gradientDivColor = "#F2F2F2";
                this.gradient = null;
            }
            else if (diagram.selectionList[0].isPseudoGroup || diagram.selectionList[0].isGroup) { // Multiple element selection
                var nodes = diagram.selectionList[0].children;
                for (var i = 0; i < nodes.length; i++) {
                    var elemnt = diagram.nameTable[nodes[i]];
                    if (elemnt.shape) {
                        if (selectedNodeItem.length == 1) {
                            this.commonforFirstNodeSelect(elemnt);
                        }
                        else {
                            selectedNodeItem.push(elemnt);
                            if (this.offsetX != elemnt.offsetX) {
                                DisableNumericTextbox("offsetxnumeric");
                            }
                            if (this.opacity != elemnt.opacity * 100) {
                                DisableSlider("opacity");
                            }
                            if (this.offsetY != elemnt.offsetY) {
                                DisableNumericTextbox("offsetynumeric");
                            }
                            if (this.width != elemnt.width) {
                                DisableNumericTextbox("widthnumeric");
                            }
                            if (this.height != elemnt.height) {
                                DisableNumericTextbox("heightnumeric");
                            }
                            if (this.aspectRatio != ((elemnt.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) ? true : false)) {
                                DisableCheckBox("aspectratioCheckBox");
                            }
                            if (this.fillColor != elemnt.fillColor) {
                                this.fillColor = "Transparent";
                            }
                            if (this.stroke != elemnt.borderColor) {
                                this.stroke = "Transparent";
                            }
                            if (this.borderthickness != elemnt.borderWidth) {
                                setThickness(null, "borderWidth")
                            }
                            if (elemnt.constraints != ej.datavisualization.Diagram.NodeConstraints.Select) {
                                this.lock = false;
                                this.lockConstrains[elemnt.name] = elemnt.constraints;
                                this.lockfontColor = "#7F7F7F";
                                this.lockDivColor = "#F9F9F9";
                            }

                            if ((this.gradient && elemnt.gradient == null) || (!this.gradient && elemnt.gradient != null)) {
                                this.gradientDivColor = "#F2F2F2";
                            }
                            var labels = elemnt.labels;
                            if (!this.label) {
                                if (labels.length > 0) {
                                    for (var j = 0; j < labels.length; j++) {
                                        if (labels[j].text.length > 0) {
                                            if (this.bold != labels[j].bold) {
                                                this.bold = false;
                                                this.boldDivColor = ko.observable("#F9F9F9");
                                                this.boldfontColor = ko.observable("#7F7F7F");
                                            }
                                            if (this.italic != labels[j].italic) {
                                                this.italic = false;
                                                this.italicDivColor = ko.observable("#F9F9F9");
                                                this.italicfontColor = ko.observable("#7F7F7F");
                                            }
                                            if (this.labelfontColor != labels[j].fontColor) {
                                                this.labelfontColor = "Transparent";
                                            }
                                            if (this.labelfontSize != labels[j].fontSize) {
                                                SetLabelSizeAndFamilyToDropDown("fontsizediffer");
                                            }
                                            if (this.labelfontFamily != labels[j].fontFamily) {
                                                SetLabelSizeAndFamilyToDropDown("fontFamilydiffer");
                                            }
                                            if (this.textAlign != labels[j].textAlign) {
                                                this.textLeftAlign = false;
                                                this.textLeftAlignfont = "#7F7F7F";
                                                this.textLeftAlignDiv = "#F9F9F9";
                                                this.textRightAlign = false;
                                                this.textRightAlignfont = "#7F7F7F";
                                                this.textRightAlignDiv = "#F9F9F9";
                                                this.textCenterAlign = false;
                                                this.textCenterAlignfont = "#7F7F7F";
                                                this.textCenterAlignDiv = "#F9F9F9";
                                            }
                                        }
                                        else {
                                            this.labelfontColor = "#DDDBDB";
                                            this.fontColorDiv = "#F2F2F2";
                                            this.fontCornerColor = "#F2F2F2";
                                            DisableState("fontColor");
                                            this.bold = null;
                                            this.boldDivColor = ko.observable("#F2F2F2");
                                            this.boldfontColor = ko.observable("#DDDBDB");
                                            this.italic = null;
                                            this.italicDivColor = ko.observable("#F2F2F2");
                                            this.italicfontColor = ko.observable("#DDDBDB");
                                            SetLabelSizeAndFamilyToDropDown(null);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else if (elemnt.segments) {
                        selectedConnectorItem.push(elemnt);
                        var item = elemnt;
                        if (selectedConnectorItem.length == 1) {
                            this.commonforFirstConnectorSelect(item);
                        }
                        else {
                            if (this.lineColor != item.lineColor) {
                                this.lineColor = "Transparent";
                            }
                            if (this.lineWidth != item.lineWidth) {
                                setThickness(null, "lineWidth");
                            }
                            if ((item.sourceDecorator && this.headDecorator == null) || (item.sourceDecorator == null && this.headDecorator != null) || (this.headDecorator != null && item.sourceDecorator != null && this.headDecorator.shape != item.sourceDecorator.shape)) {
                                this.headDecorator = null;
                            }
                            if ((item.targetDecorator && this.tailDecorator == null) || (item.targetDecorator == null && this.tailDecorator != null) || (this.tailDecorator != null && item.targetDecorator != null && this.tailDecorator.shape != item.targetDecorator.shape)) {
                                this.tailDecorator = null;
                            }
                            if (this.line && this.line[0].type != item.segments[0].type) {
                                this.line = null;
                            }
                            if (item.constraints != ej.datavisualization.Diagram.ConnectorConstraints.Select) {
                                this.lock = false;
                                this.lockConstrains[item.name] = item.constraints;
                                this.lockfontColor = "#7F7F7F";
                                this.lockDivColor = "#F9F9F9";
                            }
                            if (!(item.constraints & ej.datavisualization.Diagram.ConnectorConstraints.AspectRatio))
                                this.aspectRatio = false;
                            var labels = item.labels;
                            if (!this.label) {
                                if (labels.length > 0) {
                                    for (var j = 0; j < labels.length; j++) {
                                        if (labels[j].text.length > 0) {
                                            if (this.bold != labels[j].bold) {
                                                this.bold = false;
                                                this.boldDivColor = ko.observable("#F9F9F9");
                                                this.boldfontColor = ko.observable("#7F7F7F");
                                            }
                                            if (this.italic != labels[j].italic) {
                                                this.italic = false;
                                                this.italicDivColor = ko.observable("#F9F9F9");
                                                this.italicfontColor = ko.observable("#7F7F7F");
                                            }
                                            if (this.labelfontColor != labels[j].fontColor) {
                                                this.labelfontColor = "Transparent";
                                            }
                                            if (this.labelfontSize != labels[j].fontSize) {
                                                SetLabelSizeAndFamilyToDropDown("fontsizediffer");
                                            }
                                            if (this.labelfontFamily != labels[j].fontFamily) {
                                                SetLabelSizeAndFamilyToDropDown("fontFamilydiffer");
                                            }
                                        }
                                        else {
                                            this.labelfontColor = "#DDDBDB";
                                            this.fontColorDiv = "#F2F2F2";
                                            this.fontCornerColor = "#F2F2F2";
                                            DisableState("fontColor");
                                            this.bold = null;
                                            this.boldDivColor = ko.observable("#F2F2F2");
                                            this.boldfontColor = ko.observable("#DDDBDB");
                                            this.italic = null;
                                            this.italicDivColor = ko.observable("#F2F2F2");
                                            this.italicfontColor = ko.observable("#DDDBDB");
                                            SetLabelSizeAndFamilyToDropDown(null);
                                        }
                                    }
                                }
                            }
                            else if (item.shape && item.shape.type == "text") {
                                var label = item.shape.textBlock;
                                if (this.bold != label.bold) {
                                    this.bold = null;
                                    this.boldDivColor = ko.observable("#F2F2F2");
                                    this.boldfontColor = ko.observable("#DDDBDB");
                                }
                                if (this.italic != label.italic) {
                                    this.italic = null;
                                    this.italicDivColor = ko.observable("#F2F2F2");
                                    this.italicfontColor = ko.observable("#DDDBDB");
                                }
                                if (this.labelfontColor != label.fontColor) {
                                    this.labelfontColor = "#DDDBDB";
                                    this.fontColorDiv = "#F2F2F2";
                                    this.fontCornerColor = "#F2F2F2";
                                    DisableState("fontColor");
                                }
                            }

                        }

                    }
                }
            }
            else if (diagram.selectionList[0].shape) {  // single Node Selection
                this.commonforFirstNodeSelect(item);
            }
            else if (diagram.selectionList[0].segments) {
                this.commonforFirstConnectorSelect(item);

            }
        }
        else if (diagram.selectionList.length == 0) {
            this.offsetX = null;
            this.offsetY = null;
            this.width = null;
            this.height = null;
            this.aspectRatio = null;

            this.fillColor = "#DDDBDB";
            this.fillDivColor = "#F2F2F2";
            this.fillCornerColor = "#F2F2F2";
            DisableState("fillColor");

            this.stroke = "#DDDBDB";
            this.strokeDivColor = "#F2F2F2";
            this.strokeCornerColor = "#F2F2F2";
            this.strokePenColor = "#DDDBDB";
            DisableState("stroke");

            this.borderthickness = null;
            this.borderthicknessfontColor = "#DDDBDB";
            this.borderthicknessDivColor = "#F2F2F2";
            this.borderthicknessCornerColor = "#F2F2F2";
            DisableState("borderWidth");


            this.gradientfontColor = "#DDDBDB";
            this.gradientDivColor = "#F2F2F2";
            this.gradient = null;

            this.lock = null;
            this.lockfontColor = "#DDDBDB";
            this.lockDivColor = "#F2F2F2";

            DisableNumericTextbox("offsetxnumeric");
            DisableNumericTextbox("offsetynumeric");
            DisableNumericTextbox("widthnumeric");
            DisableNumericTextbox("heightnumeric");
            DisableCheckBox("aspectratioCheckBox");

            this.lineColor = "#DDDBDB";
            this.lineDivColor = "#F2F2F2";
            this.lineColorCorner = "#F2F2F2";
            DisableState("lineColor");

            this.line = null;
            this.lineconnectorfontColor = "#DDDBDB";
            this.lineconnectorDivColor = "#F2F2F2";
            this.lineconnectorCornerColor = "#F2F2F2";
            DisableState("line");

            this.lineWidth = null;
            this.lineWidthfontColor = "#DDDBDB";
            this.lineWidthDivColor = "#F2F2F2";
            this.lineWidthCornerColor = "#F2F2F2";
            DisableState("lineWidth");

            this.headDecorator = null;
            this.headDecoratorfontColor = "#DDDBDB";
            this.headDecoratorDivColor = "#F2F2F2";
            this.headDecoratorCornerColor = "#F2F2F2";
            DisableState("headDecorator");

            this.tailDecorator = null;
            this.tailDecoratorfontColor = "#DDDBDB";
            this.tailDecoratorDivColor = "#F2F2F2";
            this.tailDecoratorCornerColor = "#F2F2F2";
            DisableState("tailDecorator");

            this.lineStylefontColor = "#DDDBDB";
            this.lineStyleDivColor = "#F2F2F2";
            this.lineStyleCornerColor = "#F2F2F2";
            DisableState("lineStyle");

            this.labelfontColor = "#DDDBDB";
            this.fontColorDiv = "#F2F2F2";
            this.fontCornerColor = "#F2F2F2";
            DisableState("fontColor");
            this.bold = null;
            this.boldDivColor = ko.observable("#F2F2F2");
            this.boldfontColor = ko.observable("#DDDBDB");
            this.italic = null;
            this.italicDivColor = ko.observable("#F2F2F2");
            this.italicfontColor = ko.observable("#DDDBDB");
            this.textCenterAlign = null;
            this.textCenterAlignfont = "#DDDBDB";
            this.textCenterAlignDiv = "#F2F2F2";
            this.textLeftAlign = null;
            this.textLeftAlignfont = "#DDDBDB";
            this.textLeftAlignDiv = "#F2F2F2";
            this.textRightAlign = null;
            this.textRightAlignfont = "#DDDBDB";
            this.textRightAlignDiv = "#F2F2F2";
            SetLabelSizeAndFamilyToDropDown(null);
        }
        return this;
    };

    SelectorVMClass.prototype.commonforFirstNodeSelect = function (item) {
        selectedNodeItem.push(item);
        EnableNodeDropDown(item);
        this.offsetX = item.offsetX;
        this.offsetY = item.offsetY;
        this.width = item.width;
        this.height = item.height;
        this.aspectRatio = (item.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) ? true : false;
        setNodeSizeAndDimensionsToNumericTextbox(item);
        this.fillColor = item.fillColor;
        this.stroke = item.borderColor;
        this.opacity = item.opacity * 100;
        setOpacityToSlider(item);
        if (item.gradient != null) {
            this.gradient = true;
            this.gradientDivColor = "#28B1BF";
        }
        else {
            this.gradient = false;
            this.gradientDivColor = "#F9F9F9";
        }
        this.fillDivColor = "#F9F9F9";
        this.fillCornerColor = "#A3A2A2";
        this.strokeDivColor = "#F9F9F9";
        this.strokeCornerColor = "#A3A2A2";
        this.strokePenColor = "#7F7F7F";
        this.borderthickness = item.borderWidth;
        this.borderthicknessfontColor = "#7F7F7F";
        this.borderthicknessDivColor = "#F9F9F9";
        this.borderthicknessCornerColor = "#A3A2A2";
        setThickness(item, "borderWidth");
        if (item.shape.type == "text") {
            var opacity = $("#opacity").ejSlider("instance");
            opacity.disable();

            this.gradientfontColor = "#DDDBDB";
            this.gradientDivColor = "#F2F2F2";
            this.gradient = null;

            this.fillColor = "#DDDBDB";
            this.fillDivColor = "#F2F2F2";
            this.fillCornerColor = "#F2F2F2";

            this.stroke = "#DDDBDB";
            this.strokeDivColor = "#F2F2F2";
            this.strokeCornerColor = "#F2F2F2";
            this.strokePenColor = "#DDDBDB";
            DisableState("stroke");

            this.borderthickness = null;
            this.borderthicknessfontColor = "#DDDBDB";
            this.borderthicknessDivColor = "#F2F2F2";
            this.borderthicknessCornerColor = "#F2F2F2";
            DisableState("borderWidth");
        }
        if (item.constraints != ej.datavisualization.Diagram.NodeConstraints.Select) {
            this.lock = false;
            this.lockfontColor = "#7F7F7F";
            this.lockDivColor = "#F9F9F9";
            this.lockConstrains[item.name] = item.constraints;
        }
        else {
            this.lock = true;
            this.lockfontColor = "#FFFFFF";
            this.lockDivColor = "#28B1BF";
        }

        var labels = item.labels;
        if (labels.length > 0) {
            for (var j = 0; j < labels.length; j++) {
                if (labels[j].text.length > 0) {
                    this.label = true;
                    this.labelfontSize = labels[j].fontSize;
                    if (labels[j].bold) {
                        this.bold = true;
                        this.boldDivColor = ko.observable("#28B1BF");
                        this.boldfontColor = ko.observable("#FFFFFF");
                    }
                    else {
                        this.bold = false;
                        this.boldDivColor = ko.observable("#F9F9F9");
                        this.boldfontColor = ko.observable("#7F7F7F");
                    }

                    if (labels[j].italic) {
                        this.italic = true;
                        this.italicDivColor = ko.observable("#28B1BF");
                        this.italicfontColor = ko.observable("#FFFFFF");
                    }
                    else {
                        this.italic = false;
                        this.italicDivColor = ko.observable("#F9F9F9");
                        this.italicfontColor = ko.observable("#7F7F7F");
                    }

                    this.labelfontColor = labels[j].fontColor;
                    this.fontColorDiv = "#F9F9F9";
                    this.fontCornerColor = "#A3A2A2";

                    this.textAlign = labels[j].textAlign;
                    switch (labels[j].textAlign) {
                        case "left":
                            {
                                this.textLeftAlign = true;
                                this.textLeftAlignfont = "#FFFFFF";
                                this.textLeftAlignDiv = "#28B1BF";
                                this.textRightAlign = false;
                                this.textRightAlignfont = "#7F7F7F";
                                this.textRightAlignDiv = "#F9F9F9";
                                this.textCenterAlign = false;
                                this.textCenterAlignfont = "#7F7F7F";
                                this.textCenterAlignDiv = "#F9F9F9";
                                break;
                            }
                        case "right":
                            {
                                this.textRightAlign = true;
                                this.textRightAlignfont = "#FFFFFF";
                                this.textRightAlignDiv = "#28B1BF";
                                this.textLeftAlign = false;
                                this.textLeftAlignfont = "#7F7F7F";
                                this.textLeftAlignDiv = "#F9F9F9";
                                this.textCenterAlign = false;
                                this.textCenterAlignfont = "#7F7F7F";
                                this.textCenterAlignDiv = "#F9F9F9";
                                break;
                            }
                        case "center":
                            {
                                this.textCenterAlign = true;
                                this.textCenterAlignfont = "#FFFFFF";
                                this.textCenterAlignDiv = "#28B1BF";
                                this.textLeftAlign = false;
                                this.textLeftAlignfont = "#7F7F7F";
                                this.textLeftAlignDiv = "#F9F9F9";
                                this.textRightAlign = false;
                                this.textRightAlignfont = "#7F7F7F";
                                this.textRightAlignDiv = "#F9F9F9";
                                break;
                            }
                    }
                    this.labelfontSize = labels[j].fontSize;
                    this.labelfontFamily = labels[j].fontFamily;
                    SetLabelSizeAndFamilyToDropDown(labels[j]);
                }
                else {
                    this.label = false;
                    this.labelfontColor = "#DDDBDB";
                    this.fontColorDiv = "#F2F2F2";
                    this.fontCornerColor = "#F2F2F2";
                    DisableState("fontColor");

                    this.bold = null;
                    this.boldfontColor = ko.observable("#DDDBDB");
                    this.boldDivColor = ko.observable("#F2F2F2");

                    this.italic = null;
                    this.italicfontColor = ko.observable("#DDDBDB");
                    this.italicDivColor = ko.observable("#F2F2F2");

                    this.textCenterAlign = null;
                    this.textCenterAlignfont = "#DDDBDB";
                    this.textCenterAlignDiv = "#F2F2F2";
                    this.textLeftAlign = null;
                    this.textLeftAlignfont = "#DDDBDB";
                    this.textLeftAlignDiv = "#F2F2F2";
                    this.textRightAlign = null;
                    this.textRightAlignfont = "#DDDBDB";
                    this.textRightAlignDiv = "#F2F2F2";

                    SetLabelSizeAndFamilyToDropDown(null);
                }
            }
        }
        else if (item.shape && item.shape.type === "text") {
            var label = item.shape.textBlock;
            if (label.bold) {
                //this.bold = ko.observable("#28B1BF");
                this.bold = true;
                this.boldDivColor = ko.observable("#28B1BF");
                this.boldfontColor = ko.observable("#FFFFFF");
            }
            else {
                //this.bold = ko.observable("#F9F9F9");
                this.bold = false;
                this.boldDivColor = ko.observable("#F9F9F9");
                this.boldfontColor = ko.observable("#7F7F7F");
            }

            if (label.italic) {
                //this.italic = ko.observable("#28B1BF");
                this.italic = true;
                this.italicDivColor = ko.observable("#28B1BF");
                this.italicfontColor = ko.observable("#FFFFFF");
            }
            else {
                //this.italic = ko.observable("#F9F9F9");
                this.italic = false;
                this.italicDivColor = ko.observable("#F9F9F9");
                this.italicfontColor = ko.observable("#7F7F7F");
            }

            //this.labelfontsize = labels[j].fontSize - 8;
            if (this.labelfontColor != label.fontColor) {

                this.labelfontColor = label.fontColor;
                this.fontColorDiv = "#F9F9F9";
                this.fontCornerColor = "#A3A2A2";
            }
            else {
                this.labelfontColor = null;
            }

            switch (label.textAlign) {
                case "left":
                    {
                        this.textLeftAlign = true;
                        this.textLeftAlignfont = "#FFFFFF";
                        this.textLeftAlignDiv = "#28B1BF";
                        this.textRightAlign = false;
                        this.textRightAlignfont = "#7F7F7F";
                        this.textRightAlignDiv = "#F9F9F9";
                        this.textCenterAlign = false;
                        this.textCenterAlignfont = "#7F7F7F";
                        this.textCenterAlignDiv = "#F9F9F9";
                        break;
                    }
                case "right":
                    {
                        this.textRightAlign = true;
                        this.textRightAlignfont = "#FFFFFF";
                        this.textRightAlignDiv = "#28B1BF";
                        this.textLeftAlign = false;
                        this.textLeftAlignfont = "#7F7F7F";
                        this.textLeftAlignDiv = "#F9F9F9";
                        this.textCenterAlign = false;
                        this.textCenterAlignfont = "#7F7F7F";
                        this.textCenterAlignDiv = "#F9F9F9";
                        break;
                    }
                case "center":
                    {
                        this.textCenterAlign = true;
                        this.textCenterAlignfont = "#FFFFFF";
                        this.textCenterAlignDiv = "#28B1BF";
                        this.textLeftAlign = false;
                        this.textLeftAlignfont = "#7F7F7F";
                        this.textLeftAlignDiv = "#F9F9F9";
                        this.textRightAlign = false;
                        this.textRightAlignfont = "#7F7F7F";
                        this.textRightAlignDiv = "#F9F9F9";
                        break;
                    }
            }

            SetLabelSizeAndFamilyToDropDown(label);
        }
        else {
            this.label = false;
            this.labelfontColor = "#DDDBDB";
            this.fontColorDiv = "#F2F2F2";
            this.fontCornerColor = "#F2F2F2";
            DisableState("fontColor");

            this.bold = null;
            this.boldfontColor = ko.observable("#DDDBDB");
            this.boldDivColor = ko.observable("#F2F2F2");

            this.italic = null;
            this.italicfontColor = ko.observable("#DDDBDB");
            this.italicDivColor = ko.observable("#F2F2F2");

            this.textCenterAlign = null;
            this.textCenterAlignfont = "#DDDBDB";
            this.textCenterAlignDiv = "#F2F2F2";
            this.textLeftAlign = null;
            this.textLeftAlignfont = "#DDDBDB";
            this.textLeftAlignDiv = "#F2F2F2";
            this.textRightAlign = null;
            this.textRightAlignfont = "#DDDBDB";
            this.textRightAlignDiv = "#F2F2F2";
            SetLabelSizeAndFamilyToDropDown(null);
        }

        if (diagram.selectionList[0].isPseudoGroup) {
            for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                if (!elemnt.segments) {
                    // Set default value to Connector properties when Node only selected
                    this.lineColor = "#DDDBDB";
                    this.lineDivColor = "#F2F2F2";
                    this.lineColorCorner = "#F2F2F2";
                    DisableState("lineColor");

                    this.line = null;
                    this.lineconnectorfontColor = "#DDDBDB";
                    this.lineconnectorDivColor = "#F2F2F2";
                    this.lineconnectorCornerColor = "#F2F2F2";
                    DisableState("line");

                    this.lineWidth = null;
                    this.lineWidthfontColor = "#DDDBDB";
                    this.lineWidthDivColor = "#F2F2F2";
                    this.lineWidthCornerColor = "#F2F2F2";
                    DisableState("lineWidth");

                    this.headDecorator = null;
                    this.headDecoratorfontColor = "#DDDBDB";
                    this.headDecoratorDivColor = "#F2F2F2";
                    this.headDecoratorCornerColor = "#F2F2F2";
                    DisableState("headDecorator");

                    this.tailDecorator = null;
                    this.tailDecoratorfontColor = "#DDDBDB";
                    this.tailDecoratorDivColor = "#F2F2F2";
                    this.tailDecoratorCornerColor = "#F2F2F2";
                    DisableState("tailDecorator");

                    this.lineStylefontColor = "#DDDBDB";
                    this.lineStyleDivColor = "#F2F2F2";
                    this.lineStyleCornerColor = "#F2F2F2";
                    DisableState("lineStyle");
                }
                else {
                    EnableConnectorDropDown(elemnt);
                    break;
                }
            }
        }
    };

    SelectorVMClass.prototype.commonforFirstConnectorSelect = function (item) {
        EnableConnectorDropDown();
        selectedConnectorItem.push(item);

        this.lineColor = item.lineColor;
        this.lineWidth = item.lineWidth;
        this.headDecorator = item.sourceDecorator;
        this.tailDecorator = item.targetDecorator;
        setSourceOrTargetDecoratortoPanel(item);
        this.line = item.segments;
        this.lineDivColor = "#F9F9F9";
        this.lineColorCorner = "#A3A2A2";
        this.lineWidthDivColor = "#F9F9F9";
        this.lineWidthfontColor = null;
        this.lineWidthCornerColor = "#A3A2A2";
        setThickness(item, "lineWidth");
        if (item.constraints != ej.datavisualization.Diagram.ConnectorConstraints.Select)
            this.lockConstrains[item.name] = item.constraints;
        this.lineconnectorDivColor = "#F9F9F9";
        this.lineconnectorCornerColor = "#A3A2A2";
        this.lineconnectorfontColor = null;
        this.headDecoratorDivColor = "#F9F9F9";
        this.headDecoratorfontColor = null;
        this.headDecoratorCornerColor = "#A3A2A2";
        this.tailDecoratorDivColor = "#F9F9F9";
        this.tailDecoratorfontColor = null;
        this.tailDecoratorCornerColor = "#A3A2A2";
        this.lineStylefontColor = "#7F7F7F";
        this.lineStyleDivColor = "#F9F9F9";
        this.lineStyleCornerColor = "#A3A2A2";
        var labels = item.labels;
        if (labels.length > 0) {
            for (var i = 0; i < labels.length; i++) {
                if (labels[i].text.length > 0) {
                    this.label = true
                    if (labels[i].bold) {
                        this.bold = true;
                        this.boldDivColor = ko.observable("#28B1BF");
                        this.boldfontColor = ko.observable("#FFFFFF");
                    }
                    else {
                        this.bold = false;
                        this.boldDivColor = ko.observable("#F9F9F9");
                        this.boldfontColor = ko.observable("#7F7F7F");
                    }

                    if (labels[i].italic) {
                        this.italic = true;
                        this.italicDivColor = ko.observable("#28B1BF");
                        this.italicfontColor = ko.observable("#FFFFFF");
                    }
                    else {
                        this.italic = false;
                        this.italicDivColor = ko.observable("#F9F9F9");
                        this.italicfontColor = ko.observable("#7F7F7F");
                    }

                    this.labelfontsize = labels[i].fontSize - 8;
                    this.labelfontColor = labels[i].fontColor;
                    this.fontColorDiv = "#F9F9F9";
                    this.fontColorDiv = "#F9F9F9";
                    this.fontCornerColor = "#A3A2A2";

                    this.textAlign = labels[i].textAlign;
                    switch (labels[i].textAlign) {
                        case "left":
                            {
                                this.textLeftAlign = true;
                                this.textLeftAlignfont = "#FFFFFF";
                                this.textLeftAlignDiv = "#28B1BF";
                                this.textRightAlign = false;
                                this.textRightAlignfont = "#7F7F7F";
                                this.textRightAlignDiv = "#F9F9F9";
                                this.textCenterAlign = false;
                                this.textCenterAlignfont = "#7F7F7F";
                                this.textCenterAlignDiv = "#F9F9F9";
                                break;
                            }
                        case "right":
                            {
                                this.textRightAlign = true;
                                this.textRightAlignfont = "#FFFFFF";
                                this.textRightAlignDiv = "#28B1BF";
                                this.textLeftAlign = false;
                                this.textLeftAlignfont = "#7F7F7F";
                                this.textLeftAlignDiv = "#F9F9F9";
                                this.textCenterAlign = false;
                                this.textCenterAlignfont = "#7F7F7F";
                                this.textCenterAlignDiv = "#F9F9F9";
                                break;
                            }
                        case "center":
                            {
                                this.textCenterAlign = true;
                                this.textCenterAlignfont = "#FFFFFF";
                                this.textCenterAlignDiv = "#28B1BF";
                                this.textLeftAlign = false;
                                this.textLeftAlignfont = "#7F7F7F";
                                this.textLeftAlignDiv = "#F9F9F9";
                                this.textRightAlign = false;
                                this.textRightAlignfont = "#7F7F7F";
                                this.textRightAlignDiv = "#F9F9F9";
                                break;
                            }
                    }
                    this.labelfontSize = labels[i].fontSize;
                    this.labelfontFamily = labels[i].fontFamily;
                    SetLabelSizeAndFamilyToDropDown(labels[i]);
                }
                else {
                    this.label = false;
                    this.labelfontColor = "#DDDBDB";
                    this.fontColorDiv = "#F2F2F2";
                    this.fontCornerColor = "#F2F2F2";
                    DisableState("fontColor");

                    this.bold = null;
                    this.boldfontColor = ko.observable("#DDDBDB");
                    this.boldDivColor = ko.observable("#F2F2F2");

                    this.italic = null;
                    this.italicfontColor = ko.observable("#DDDBDB");
                    this.italicDivColor = ko.observable("#F2F2F2");

                    this.textCenterAlign = null;
                    this.textCenterAlignfont = "#DDDBDB";
                    this.textCenterAlignDiv = "#F2F2F2";
                    this.textLeftAlign = null;
                    this.textLeftAlignfont = "#DDDBDB";
                    this.textLeftAlignDiv = "#F2F2F2";
                    this.textRightAlign = null;
                    this.textRightAlignfont = "#DDDBDB";
                    this.textRightAlignDiv = "#F2F2F2";

                    SetLabelSizeAndFamilyToDropDown(null);
                }
            }
        }
        else {
            this.labelfontColor = "#DDDBDB";
            this.fontColorDiv = "#F2F2F2";
            this.fontCornerColor = "#F2F2F2";
            DisableState("fontColor");

            this.bold = null;
            this.boldfontColor = ko.observable("#DDDBDB");
            this.boldDivColor = ko.observable("#F2F2F2");

            this.italic = null;
            this.italicfontColor = ko.observable("#DDDBDB");
            this.italicDivColor = ko.observable("#F2F2F2");

            this.textCenterAlign = null;
            this.textCenterAlignfont = "#DDDBDB";
            this.textCenterAlignDiv = "#F2F2F2";
            this.textLeftAlign = null;
            this.textLeftAlignfont = "#DDDBDB";
            this.textLeftAlignDiv = "#F2F2F2";
            this.textRightAlign = null;
            this.textRightAlignfont = "#DDDBDB";
            this.textRightAlignDiv = "#F2F2F2";
            SetLabelSizeAndFamilyToDropDown(null);
        }

        if (diagram.selectionList[0].isPseudoGroup) {
            for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                if (!elemnt.shape) {
                    // Set default value to Connector properties when Node only selected

                    this.fillColor = "#DDDBDB";
                    this.opacity = item.opacity * 100;
                    this.fillDivColor = "#F2F2F2";
                    this.fillCornerColor = "#F2F2F2";
                    DisableState("fillColor");
                    this.stroke = "#DDDBDB";
                    this.strokeDivColor = "#F2F2F2";
                    this.strokeCornerColor = "#F2F2F2";
                    this.strokePenColor = "#DDDBDB";
                    DisableState("stroke");

                    this.borderthickness = null;
                    this.borderthicknessfontColor = "#DDDBDB";
                    this.borderthicknessDivColor = "#F2F2F2";
                    this.borderthicknessCornerColor = "#F2F2F2";
                    DisableState("borderWidth");


                    this.gradientfontColor = "#DDDBDB";
                    this.gradientDivColor = "#F2F2F2";
                    this.gradient = null;

                    this.lock = null;
                    this.lockfontColor = "#DDDBDB";
                    this.lockDivColor = "#F2F2F2";
                }
                else {
                    EnableNodeDropDown(elemnt);
                    for (var j = 0; j < diagram.selectionList[0].children.length; j++) {
                        var element = diagram.nameTable[diagram.selectionList[0].children[j]];
                        if (element.shape) {
                            if (j == 0) {
                                this.offsetX = element.offsetX;
                                this.offsetY = element.offsetY;
                                this.width = element.width;
                                this.height = element.height;
                                this.aspectRatio = (element.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) ? true : false;
                            }
                            else {
                                if (this.offsetX != element.offsetX) {
                                    DisableNumericTextbox("offsetxnumeric");
                                }
                                if (this.offsetY != element.offsetY) {
                                    DisableNumericTextbox("offsetynumeric");
                                }
                                if (this.width != element.width) {
                                    DisableNumericTextbox("widthnumeric");
                                }
                                if (this.height != element.height) {
                                    DisableNumericTextbox("heightnumeric");
                                }
                                if (this.aspectRatio != ((element.constraints & ej.datavisualization.Diagram.NodeConstraints.AspectRatio) ? true : false)) {
                                    DisableCheckBox("aspectratioCheckBox");
                                }
                            }
                        }
                    }
                    break;
                }
            }
        }
    };

    SelectorVMClass.prototype.method = function (args, prop) {
        var diagram = $("#DiagramContent").ejDiagram("instance");
        var aspectratio = $('#aspectratioCheckBox').ejCheckBox("instance");
        var option = new Object;
        if (diagram.selectionList && diagram.selectionList.length > 0) {
            if (selectedNodeItem.length > 0) {
                ExitForPseudoGroup: {
                    for (var j = 0; j < selectedNodeItem.length; j++) {
                        var item = selectedNodeItem[j];
                        switch (prop) {
                            case "width":
                                {
                                    if (item.width != args.value) {
                                        option.width = args.value;
                                        if (aspectratio._isChecked)
                                            option.height = item.height + args.value - item.width;
                                        diagram.updateNode(item.name, option);
                                    }
                                    break;
                                }
                            case "height":
                                {
                                    if (item.height != args.value) {
                                        option.height = args.value;
                                        if (aspectratio._isChecked) 
                                            option.width = item.width + args.value - item.height;
                                        diagram.updateNode(item.name, option);
                                    }
                                    break;
                                }
                            case "aspectRatio":
                                {
                                    diagram.updateNode(item.name, { constraints: item.constraints ^ ej.datavisualization.Diagram.NodeConstraints.AspectRatio });
                                    break;
                                }
                            case "pinX":
                                {
                                    if (item.offsetX != args.value) {
                                        option.offsetX = args.value;
                                        diagram.updateNode(item.name, option);
                                    }
                                    break;
                                }
                            case "pinY":
                                {
                                    if (item.offsetY != args.value) {
                                        option.offsetY = args.value;
                                        diagram.updateNode(item.name, option);
                                    }
                                    break;
                                }
                            case "borderWidth":
                                {
                                    var obj = new Object();
                                    obj.borderWidth = Number(String(args.text).substring(0, args.text.length - 3));
                                    diagram.updateNode(item.name, obj);
                                    this.borderthickness = item.borderWidth;
                                    break;
                                }
                            case "Gradient":
                                {
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        
                                        if (this.gradient != null) {
                                            if (this.gradient) {
                                                for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                                    elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                                                    if (elemnt.shape) {
                                                        obj = new Object();
                                                        obj.gradient = null;
                                                        diagram.updateNode(elemnt.name, obj);
                                                        this.gradient = false;
                                                        this.gradientDivColor = "#F9F9F9";
                                                    }
                                                }
                                            } else {
                                                for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                                    elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                                                    if (elemnt.shape) {
                                                        obj = new Object();
                                                        obj.gradient = this.getNewGradient(elemnt.fillColor);
                                                        diagram.updateNode(elemnt.name, obj);
                                                        this.gradient = true;
                                                        this.gradientDivColor = "#28B1BF";
                                                    }
                                                }
                                            }
                                        }
                                        break ExitForPseudoGroup;
                                    } else {
                                        if (this.gradient != null) {
                                            obj = new Object();
                                            if (item.gradient == null) {
                                                obj.gradient = this.getNewGradient(item.fillColor);
                                                diagram.updateNode(item.name, obj);
                                                this.gradient = true;
                                                this.gradientDivColor = "#28B1BF";
                                            } else {
                                                obj.gradient = null;
                                                diagram.updateNode(item.name, obj);
                                                this.gradient = false;
                                                this.gradientDivColor = "#F9F9F9";
                                            }
                                        }
                                    }
                                }
                                break;
                            case "Lock":
                                {
                                    var value = null;
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        if (this.lock != null) {
                                            if (this.lock) {
                                                for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                                    var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                                                    if (elemnt.shape) {
                                                        value = this.lockConstrains[elemnt.name];
                                                        //value = ej.datavisualization.Diagram.NodeConstraints.Default ^ (ej.datavisualization.Diagram.NodeConstraints.InConnect | ej.datavisualization.Diagram.NodeConstraints.OutConnect | ej.datavisualization.Diagram.NodeConstraints.Connect);
                                                        diagram.updateNode(elemnt.name, { constraints: value });
                                                    }
                                                    else if(elemnt.segments)
                                                    {
                                                        value = this.lockConstrains[elemnt.name];
                                                        //value = ej.datavisualization.Diagram.ConnectorConstraints.Select | ej.datavisualization.Diagram.ConnectorConstraints.Delete;
                                                        diagram.updateConnector(elemnt.name, { constraints: value });
                                                    }
                                                    this.lock = false;
                                                    this.lockfontColor = "#7F7F7F";
                                                    this.lockDivColor = "#F9F9F9";
                                                }
                                            } else {
                                                for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                                    var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];
                                                    this.lockConstrains[elemnt.name] = elemnt.constraints;
                                                    if (elemnt.shape) {
                                                        value = ej.datavisualization.Diagram.NodeConstraints.Select;
                                                        diagram.updateNode(elemnt.name, { constraints: value });
                                                    }
                                                    else if(elemnt.segments)
                                                    {
                                                        value = ej.datavisualization.Diagram.ConnectorConstraints.Select;
                                                        diagram.updateConnector(elemnt.name, { constraints: value });
                                                    }
                                                    this.lock = true;
                                                    this.lockfontColor = "#FFFFFF";
                                                    this.lockDivColor = "#28B1BF";
                                                }
                                            }
                                        }
                                        break ExitForPseudoGroup;
                                    } else {
                                        if (this.lock != null) {
                                            if (item.constraints != ej.datavisualization.Diagram.NodeConstraints.Select) {
                                                this.lockConstrains[item.name] = item.constraints;
                                                value = ej.datavisualization.Diagram.NodeConstraints.Select;
                                                this.lock = true;
                                                this.lockfontColor = "#FFFFFF";
                                                this.lockDivColor = "#28B1BF";
                                            } else {
                                                value = this.lockConstrains[item.name];
                                                this.lock = false;
                                                this.lockfontColor = "#7F7F7F";
                                                this.lockDivColor = "#F9F9F9";
                                            }
                                        }
                                        var options = new Object();
                                        options.constraints = value;
                                        diagram.updateNode(item.name, options);
                                    }
                                    break;
                                }

                            case "Fill":
                                {
                                    var obj = new Object();
                                    if (item.gradient != null) {
                                       obj.fillColor = args.style.backgroundColor;
                                        diagram._modified = true;
                                        obj.gradient = this.getNewGradient(args.style.backgroundColor);
                                        diagram.updateNode(item.name, obj);
                                        this.gradient = true;
                                        this.gradientDivColor = "#28B1BF";
                                        this.fillColor = ko.observable(args.style.backgroundColor);
                                    } else {
                                        obj.fillColor = args.style.backgroundColor;
                                        diagram.updateNode(item.name, obj);
                                        this.fillColor = ko.observable(item.fillColor);
                                    }
                                    break;
                                }
                            case "Opacity":
                                {
                                    var obj = new Object();
                                    obj.opacity = args.value / 100;
                                    item.opacity = args.value;
                                    diagram.updateNode(item.name, obj);
                                    this.opacity = ko.observable(args.value);
                                    break;
                                }
                            case "Stroke":
                                {   
                                    var obj = new Object();
                                    obj.borderColor = args.style.backgroundColor;
                                    diagram.updateNode(item.name, obj);
                                    this.stroke = ko.observable(item.borderColor);
                                    break;
                                }
                            case "TextColor":
                                {
                                    this.labelfontColor = ko.observable(args.style.backgroundColor);
                                    this.setTextColor(item, diagram, args);
                                    break;
                                }
                            case "Bold":
                                {
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        this.setBoldColor(this, diagram.selectionList[0], diagram, args);
                                        break ExitForPseudoGroup;
                                    } else
                                        this.setBoldColor(this, item, diagram, args);
                                    break;
                                }
                            case "Italic":
                                {
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        this.setItalicColor(this, diagram.selectionList[0], diagram, args);
                                        break ExitForPseudoGroup;
                                    } else
                                        this.setItalicColor(this, item, diagram, args);
                                    break;
                                }
                            case "fontSize":
                                {
                                    this.setFontSize(this, item, diagram, args);
                                    break;
                                }
                            case "fontFamily":
                                {
                                    this.setFontFamily(this, item, diagram, args);
                                    break;
                                }
                            case "Wrap":
                                {
                                    this.setWrapText(this, item, diagram, args);
                                    break;
                                }
                            case "Left":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "HCenter":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "Right":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }

                            case "Top":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "VCenter":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "Bottom":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "AlignTextLeft":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "left");
                                    this.setAlignment(this, item, diagram, args, "left");
                                    this.textLeftAlign = true;
                                    this.textLeftAlignfont = "#FFFFFF";
                                    this.textLeftAlignDiv = "#28B1BF";
                                    this.textRightAlign = false;
                                    this.textRightAlignfont = "#7F7F7F";
                                    this.textRightAlignDiv = "#F9F9F9";
                                    this.textCenterAlign = false;
                                    this.textCenterAlignfont = "#7F7F7F";
                                    this.textCenterAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "AlignTextCenter":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "center");
                                    this.setAlignment(this, item, diagram, args, "center");
                                    this.textCenterAlign = true;
                                    this.textCenterAlignfont = "#FFFFFF";
                                    this.textCenterAlignDiv = "#28B1BF";
                                    this.textLeftAlign = false;
                                    this.textLeftAlignfont = "#7F7F7F";
                                    this.textLeftAlignDiv = "#F9F9F9";
                                    this.textRightAlign = false;
                                    this.textRightAlignfont = "#7F7F7F";
                                    this.textRightAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "AlignTextRight":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "right");
                                    this.setAlignment(this, item, diagram, args, "right");
                                    this.textRightAlign = true;
                                    this.textRightAlignfont = "#FFFFFF";
                                    this.textRightAlignDiv = "#28B1BF";
                                    this.textLeftAlign = false;
                                    this.textLeftAlignfont = "#7F7F7F";
                                    this.textLeftAlignDiv = "#F9F9F9";
                                    this.textCenterAlign = false;
                                    this.textCenterAlignfont = "#7F7F7F";
                                    this.textCenterAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "LabelOffsetX":
                                {
                                    this.setOffset(this, item, diagram, args, prop);
                                    break;
                                }
                            case "LabelOffsetY":
                                {
                                    this.setOffset(this, item, diagram, args, prop);
                                    break;
                                }
                        }
                    }
                }

            }
            if (selectedConnectorItem.length > 0) {
                ExitForPseudoGroupConnect: {
                    for (var i = 0; i < selectedConnectorItem.length; i++) {
                        var item = selectedConnectorItem[i];
                        switch (prop) {
                            case "LineStrokeColor":
                                {
                                    var obj = new Object();
                                    obj.lineColor = args.style.backgroundColor;
                                    obj.sourceDecorator = item.sourceDecorator;
                                    obj.sourceDecorator.borderColor = args.style.backgroundColor;
                                    obj.sourceDecorator.fillColor = args.style.backgroundColor;
                                    obj.targetDecorator = item.targetDecorator;
                                    obj.targetDecorator.borderColor = args.style.backgroundColor;
                                    obj.targetDecorator.fillColor = args.style.backgroundColor;
                                    diagram.updateConnector(item.name, obj);
                                    this.lineColor = ko.observable(item.lineColor);
                                    break;
                                }
                            case "LineWidth":
                                {
                                    var obj = new Object();
                                    obj.lineWidth = Number(String(args.text).substring(0, args.text.length - 3));
                                    obj.sourceDecorator = item.sourceDecorator;
                                    obj.sourceDecorator.width = obj.lineWidth * item.sourceDecorator.width / item.lineWidth;;
                                    obj.sourceDecorator.height = obj.lineWidth * item.sourceDecorator.height / item.lineWidth;
                                    obj.targetDecorator = item.targetDecorator;
                                    obj.targetDecorator.width = obj.lineWidth * item.targetDecorator.width / item.lineWidth;
                                    obj.targetDecorator.height = obj.lineWidth * item.targetDecorator.height / item.lineWidth;
                                    diagram.updateConnector(item.name, obj);
                                    this.lineWidth = item.lineWidth;
                                    break;
                                }
                            case "HeadDecorator":
                                {
                                    var obj = new Object();
                                    switch (String(args.itemId)) {
                                        case "0":
                                            obj.sourceDecorator = ej.datavisualization.Diagram.Decorator({ shape: "none", fillColor: item.lineColor });
                                            break;
                                        case "1":
                                            var headDec = ej.datavisualization.Diagram.Decorator({ shape: "arrow", fillColor: item.lineColor });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "2":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "diamond", fillColor: item.lineColor });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "3":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "circle", fillColor: item.lineColor });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "4":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "path", pathData: "M 376.892,225.284L 371.279,211.95L 376.892,198.617L 350.225,211.95L 376.892,225.284 Z", fillColor: item.lineColor });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "5":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "arrow", fillColor: "white" });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "6":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "diamond", fillColor: "white" });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "7":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "circle", fillColor: "white" });
                                            obj.sourceDecorator = headDec;
                                            break;
                                        case "8":
                                            headDec = ej.datavisualization.Diagram.Decorator({ shape: "path", pathData: "M 376.892,225.284L 371.279,211.95L 376.892,198.617L 350.225,211.95L 376.892,225.284 Z", fillColor: "white" });
                                            obj.sourceDecorator = headDec;
                                            break;
                                    }
                                    obj.sourceDecorator.width = item.sourceDecorator.width;
                                    obj.sourceDecorator.height = item.sourceDecorator.height;
                                    obj.sourceDecorator.borderColor = item.lineColor;
                                    //if (this.headDecorator.shape != obj.sourceDecorator.shape || this.headDecorator.fillColor != obj.sourceDecorator.fillColor)
                                    diagram.updateConnector(item.name, obj);
                                    this.headDecorator = item.sourceDecorator;
                                    break;
                                }
                            case "TailDecorator":
                                {
                                    var obj = new Object();
                                    switch (String(args.itemId)) {
                                        case "0":
                                            var tailDec = null;
                                            obj.targetDecorator = ej.datavisualization.Diagram.Decorator({ shape: "none", fillColor: item.lineColor });
                                            break;
                                        case "1":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "arrow", fillColor: item.lineColor });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "2":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "diamond", fillColor: item.lineColor });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "3":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "circle", fillColor: item.lineColor });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "4":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "path", pathData: "M 376.892,225.284L 371.279,211.95L 376.892,198.617L 350.225,211.95L 376.892,225.284 Z", fillColor: item.lineColor });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "5":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "arrow", fillColor: "white" });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "6":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "diamond", fillColor: "white" });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "7":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "circle", fillColor: "white" });
                                            obj.targetDecorator = tailDec;
                                            break;
                                        case "8":
                                            tailDec = ej.datavisualization.Diagram.Decorator({ shape: "path", fillColor: "white", pathData: "M 376.892,225.284L 371.279,211.95L 376.892,198.617L 350.225,211.95L 376.892,225.284 Z" });
                                            obj.targetDecorator = tailDec;
                                            break;
                                    }
                                    obj.targetDecorator.width = item.targetDecorator.width;
                                    obj.targetDecorator.height = item.targetDecorator.height;
                                    obj.targetDecorator.borderColor = item.lineColor;
                                    //if (this.tailDecorator.shape != obj.targetDecorator.shape || this.tailDecorator.borderColor != obj.targetDecorator.borderColor)
                                    diagram.updateConnector(item.name, obj);
                                    this.tailDecorator = item.targetDecorator;
                                    break;
                                }
                            case "ConnectorType":
                                var obj = new Object();
                                switch (args.text) {
                                    case "Straight":
                                        obj.segments = [{ type: "straight" }];
                                        break;
                                    case "Bezier":
                                        obj.segments = [{ type: "bezier" }];
                                        break;
                                    case "Orthogonal":
                                        obj.segments = [{ type: "orthogonal" }];
                                        break;
                                }
                                diagram.updateConnector(item.name, obj);

                                setDiagramSize(true);
                                document.getElementById("propertyEditor").style.display = "block";
                                this.line = item.segments;
                                break;

                            case "LineStyle":
                                {
                                    switch (String(args.itemId)) {
                                        case "0":
                                            var obj = new Object();
                                            obj.lineDashArray = "0,0";
                                            diagram.updateConnector(item.name, obj);
                                            break;
                                        case "1":
                                            var obj = new Object();
                                            obj.lineDashArray = "10,10";
                                            diagram.updateConnector(item.name, obj);
                                            break;
                                        case "2":
                                            var obj = new Object();
                                            obj.lineDashArray = "2,2";
                                            diagram.updateConnector(item.name, obj);
                                            break;
                                        case "3":
                                            var obj = new Object();
                                            obj.lineDashArray = "20,5,5,5";
                                            diagram.updateConnector(item.name, obj);
                                            break;
                                    }
                                    break;
                                }
                            case "TextColor":
                                {
                                    this.labelfontColor = args.style.backgroundColor;
                                    this.setTextColor(item, diagram, args);
                                    break;
                                }
                            case "Bold":
                                {
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        var pseudoGroupContainsNode = false;
                                        for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                            var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];;
                                            if (elemnt.shape) {
                                                pseudoGroupContainsNode = true;
                                            }
                                        }
                                        if (!pseudoGroupContainsNode)
                                            this.setBoldColor(this, diagram.selectionList[0], diagram, args);
                                        break ExitForPseudoGroupConnect;
                                    } else
                                        this.setBoldColor(this, item, diagram, args);
                                    break;
                                }
                            case "Italic":
                                {
                                    if (diagram.selectionList[0].isPseudoGroup) {
                                        var pseudoGroupContainsNode = false;
                                        for (var n = 0; n < diagram.selectionList[0].children.length; n++) {
                                            var elemnt = diagram.nameTable[diagram.selectionList[0].children[n]];;
                                            if (elemnt.shape) {
                                                pseudoGroupContainsNode = true;
                                            }
                                        }
                                        if (!pseudoGroupContainsNode)
                                            this.setItalicColor(this, diagram.selectionList[0], diagram, args);
                                        break ExitForPseudoGroupConnect;
                                    } else
                                        this.setItalicColor(this, item, diagram, args);
                                    break;
                                }
                            case "fontSize":
                                {
                                    this.setFontSize(this, item, diagram, args);
                                    break;
                                }
                            case "fontFamily":
                                {
                                    this.setFontFamily(this, item, diagram, args);
                                    break;
                                }
                            case "Wrap":
                                {
                                    this.setWrapText(this, item, diagram, args);
                                    break;
                                }
                            case "Left":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "HCenter":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "Right":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }

                            case "Top":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "VCenter":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }
                            case "Bottom":
                                {
                                    this.setAlignment(this, item, diagram, args, prop);
                                    break;
                                }

                            case "AlignTextLeft":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "left");
                                    this.setAlignment(this, item, diagram, args, "left");
                                    this.textLeftAlign = true;
                                    this.textLeftAlignfont = "#FFFFFF";
                                    this.textLeftAlignDiv = "#28B1BF";
                                    this.textRightAlign = false;
                                    this.textRightAlignfont = "#7F7F7F";
                                    this.textRightAlignDiv = "#F9F9F9";
                                    this.textCenterAlign = false;
                                    this.textCenterAlignfont = "#7F7F7F";
                                    this.textCenterAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "AlignTextCenter":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "center");
                                    this.setAlignment(this, item, diagram, args, "center");
                                    this.textCenterAlign = true;
                                    this.textCenterAlignfont = "#FFFFFF";
                                    this.textCenterAlignDiv = "#28B1BF";
                                    this.textLeftAlign = false;
                                    this.textLeftAlignfont = "#7F7F7F";
                                    this.textLeftAlignDiv = "#F9F9F9";
                                    this.textRightAlign = false;
                                    this.textRightAlignfont = "#7F7F7F";
                                    this.textRightAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "AlignTextRight":
                                {
                                    this.setTextAlignment(this, item, diagram, args, "right");
                                    this.setAlignment(this, item, diagram, args, "right");
                                    this.textRightAlign = true;
                                    this.textRightAlignfont = "#FFFFFF";
                                    this.textRightAlignDiv = "#28B1BF";
                                    this.textLeftAlign = false;
                                    this.textLeftAlignfont = "#7F7F7F";
                                    this.textLeftAlignDiv = "#F9F9F9";
                                    this.textCenterAlign = false;
                                    this.textCenterAlignfont = "#7F7F7F";
                                    this.textCenterAlignDiv = "#F9F9F9";
                                    break;
                                }
                            case "LabelOffsetX":
                                {
                                    this.setOffset(this, item, diagram, args, prop);
                                    break;
                                }
                            case "LabelOffsetY":
                                {
                                    this.setOffset(this, item, diagram, args, prop);
                                    break;
                                }
                            case "Lock": {
                                if (!diagram.selectionList[0].isPseudoGroup) {
                                    if (item.constraints != ej.datavisualization.Diagram.ConnectorConstraints.Select) {
                                        value = ej.datavisualization.Diagram.ConnectorConstraints.Select;
                                    } else {
                                        value = this.lockConstrains[item.name];
                                    }
                                    diagram.updateConnector(item.name, { constraints: value });
                                }
                                break;
                            }
                        }
                    }
                }
            }
        }
        return this;
    };

    SelectorVMClass.prototype.nodeDragging = function (item) {
        setNodeSizeAndDimensionsToNumericTextbox(item, "offset");
    }
    SelectorVMClass.prototype.nodeSizeChanging = function (item) {
        setNodeSizeAndDimensionsToNumericTextbox(item, "size");
    }

    SelectorVMClass.prototype.setTextColor = function (item, diagram, args) {
        var labels = item.labels;
        if (item.shape && item.shape.type == "text") {
            var obj = new Object();
            obj.fontColor = args.style.backgroundColor;
            diagram.updateLabel(item.name, item.shape.textBlock, obj);
        }
        else {
            for (var i = 0; i < labels.length; i++) {
                var obj = new Object();
                obj.fontColor = args.style.backgroundColor;
                diagram.updateLabel(item.name, labels[i], obj);
            }
        }
    }

    SelectorVMClass.prototype.setBoldColor = function (model, item, diagram, args) {
        if (item.isPseudoGroup) {
            var obj = new Object();
            if (this.bold != null) {
                if (this.bold) {
                    for (var n = 0; n < item.children.length; n++) {
                        obj.bold = false;
                        model.bold = false;
                        model.boldDivColor = ko.observable("#F9F9F9");
                        model.boldfontColor = ko.observable("#7F7F7F");
                        var elemnt = diagram.nameTable[item.children[n]];
                        if (elemnt.shape && elemnt.shape.type == "text") {
                            diagram.updateLabel(elemnt.name, elemnt.shape.textBlock, obj);
                        }
                        else {
                            var labels = elemnt.labels;
                            for (var i = 0; i < labels.length; i++) {
                                diagram.updateLabel(elemnt.name, labels[i], obj);
                            }
                        }
                    }
                }
                else {
                    for (var n = 0; n < item.children.length; n++) {
                        obj.bold = true;
                        model.bold = true;
                        model.boldDivColor = ko.observable("#28B1BF");
                        model.boldfontColor = ko.observable("#FFFFFF");
                        var elemnt = diagram.nameTable[item.children[n]];
                        if (elemnt.shape && elemnt.shape.type == "text") {
                            diagram.updateLabel(elemnt.name, elemnt.shape.textBlock, obj);
                        }
                        else {
                            var labels = elemnt.labels;
                            for (var i = 0; i < labels.length; i++) {
                                diagram.updateLabel(elemnt.name, labels[i], obj);
                            }
                        }
                    }
                }

            }
        }
        else {
            var labels = item.labels;
            if (item.shape && item.shape.type == "text") {
                var obj = new Object();
                if (item.shape.textBlock.italic) {
                    obj.bold = false;
                    model.bold = false;
                    model.boldDivColor = ko.observable("#F9F9F9");
                    model.boldfontColor = ko.observable("#7F7F7F");
                }
                else {
                    obj.bold = true;
                    model.bold = true;
                    model.boldDivColor = ko.observable("#28B1BF");
                    model.boldfontColor = ko.observable("#FFFFFF");
                }
                diagram.updateLabel(item.name, item.shape.textBlock, obj);
                return model.bold;
            }
            else {
                for (var i = 0; i < labels.length; i++) {

                    var obj = new Object();
                    if (labels[i].bold) {
                        obj.bold = false;
                        model.bold = false;
                        model.boldDivColor = ko.observable("#F9F9F9");
                        model.boldfontColor = ko.observable("#7F7F7F");
                    }
                    else {
                        obj.bold = true;
                        model.bold = true;
                        model.boldDivColor = ko.observable("#28B1BF");
                        model.boldfontColor = ko.observable("#FFFFFF");
                    }
                    diagram.updateLabel(item.name, labels[i], obj);
                    return model.bold;
                }
            }
        }
    }

    SelectorVMClass.prototype.setItalicColor = function (model, item, diagram, args) {
        if (item.isPseudoGroup) {
            var obj = new Object();
            if (this.italic != null) {
                if (this.italic) {
                    for (var n = 0; n < item.children.length; n++) {
                        obj.italic = false;
                        model.italic = false;
                        model.italicDivColor = ko.observable("#F9F9F9");
                        model.italicfontColor = ko.observable("#7F7F7F");
                        var elemnt = diagram.nameTable[item.children[n]];
                        if (elemnt.shape && elemnt.shape.type == "text") {
                            diagram.updateLabel(elemnt.name, elemnt.shape.textBlock, obj);
                        }
                        else {
                            var labels = elemnt.labels;
                            for (var i = 0; i < labels.length; i++) {
                                diagram.updateLabel(elemnt.name, labels[i], obj);
                            }
                        }
                    }
                }
                else {
                    for (var n = 0; n < item.children.length; n++) {
                        obj.italic = true;
                        model.italic = true;
                        model.italicDivColor = ko.observable("#28B1BF");
                        model.italicfontColor = ko.observable("#FFFFFF");
                        var elemnt = diagram.nameTable[item.children[n]];
                        if (elemnt.shape && elemnt.shape.type == "text") {
                            diagram.updateLabel(elemnt.name, elemnt.shape.textBlock, obj);
                        }
                        else {
                            var labels = elemnt.labels;
                            for (var i = 0; i < labels.length; i++) {
                                diagram.updateLabel(elemnt.name, labels[i], obj);
                            }
                        }
                    }
                }

            }
        }
        else {
            var labels = item.labels;
            if (item.shape && item.shape.type == "text") {
                var obj = new Object();
                if (item.shape.textBlock.italic) {
                    obj.italic = false;
                    model.italic = false;
                    model.italicDivColor = ko.observable("#F9F9F9");
                    model.italicfontColor = ko.observable("#7F7F7F");
                }
                else {
                    obj.italic = true;
                    model.italic = true;
                    model.italicDivColor = ko.observable("#28B1BF");
                    model.italicfontColor = ko.observable("#FFFFFF");
                }
                diagram.updateLabel(item.name, item.shape.textBlock, obj);
            }
            else {
                for (var i = 0; i < labels.length; i++) {

                    var obj = new Object();
                    if (labels[i].italic) {
                        obj.italic = false;
                        model.italic = false;
                        model.italicDivColor = ko.observable("#F9F9F9");
                        model.italicfontColor = ko.observable("#7F7F7F");
                    }
                    else {
                        obj.italic = true;
                        model.italic = true;
                        model.italicDivColor = ko.observable("#28B1BF");
                        model.italicfontColor = ko.observable("#FFFFFF");
                    }
                    diagram.updateLabel(item.name, labels[i], obj);
                }
            }
        }
    }

    SelectorVMClass.prototype.setFontSize = function (model, item, diagram, args) {
        var labels = item.labels;
        if (item.shape && item.shape.type == "text") {
            var obj = new Object();
            obj.fontSize = args.text;
            diagram.updateLabel(item.name, item.shape.textBlock, obj);
        }
        else {
            for (var i = 0; i < labels.length; i++) {
                var obj = new Object();
                obj.fontSize = Number(args.text);
                diagram.updateLabel(item.name, labels[i], obj);
            }
        }
    }

    SelectorVMClass.prototype.setAlignment = function (model, item, diagram, args, prop) {
        var labels = item.labels;
        if (item.shape && item.shape.type == "text") {
            var obj = new Object();
            obj.horizontalAlignment = prop;
            if (prop == "left")
                obj.offset = ej.datavisualization.Diagram.Point(0, 0.5);
            else if (prop == "right")
                obj.offset = ej.datavisualization.Diagram.Point(1, 0.5);
            else
                obj.offset = ej.datavisualization.Diagram.Point(0.5, 0.5);
            diagram.updateLabel(item.name, item.shape.textBlock, obj);
        }
        else {
            for (var i = 0; i < labels.length; i++) {
                var obj = new Object();
                obj.horizontalAlignment = prop;
                if (prop == "left")
                    obj.offset = ej.datavisualization.Diagram.Point(0, 0.5);
                else if (prop == "right")
                    obj.offset = ej.datavisualization.Diagram.Point(1, 0.5);
                else
                    obj.offset = ej.datavisualization.Diagram.Point(0.5, 0.5);
                diagram.updateLabel(item.name, labels[i], obj);
            }
        }
    }


    SelectorVMClass.prototype.setTextAlignment = function (model, item, diagram, args, prop) {
        var labels = item.labels;
        if (item.shape && item.shape.type == "text") {
            var obj = new Object();
            obj.textAlign = prop;
            diagram.updateLabel(item.name, item.shape.textBlock, obj);
        }
        else {
            for (var i = 0; i < labels.length; i++) {
                var obj = new Object();
                obj.textAlign = prop;
                diagram.updateLabel(item.name, labels[i], obj);
            }
        }
    }

    SelectorVMClass.prototype.setFontFamily = function (model, item, diagram, args) {
        var labels = item.labels;
        if (item.shape && item.shape.type == "text") {
            var obj = new Object();
            obj.fontFamily = args.text;
            diagram.updateLabel(item.name, item.shape.textBlock, obj);
        }
        else {
            for (var i = 0; i < labels.length; i++) {
                var obj = new Object();
                obj.fontFamily = args.text;
                diagram.updateLabel(item.name, labels[i], obj);
            }
        }
    }

    SelectorVMClass.prototype.mouseenter = function (args, prop, enter) {
        if (prop == "fillColor") {
            if (enter) {
                if (this.fillColor != "#DDDBDB") {
                    args.style.backgroundColor = "#E2E2E2";
                }

            }
            else {

                if (this.fillColor != "#DDDBDB" && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "stroke") {
            if (enter) {
                if (this.stroke != "#DDDBDB") {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.stroke != "#DDDBDB" && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "borderthickness") {
            if (enter) {
                if (this.borderthickness != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.borderthickness != null && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "gradient") {
            if (enter) {
                if (this.gradient != null)
                    args.style.backgroundColor = "#E2E2E2";
            }
            else {
                if (this.gradient != null) {
                    if (!this.gradient)
                        args.style.backgroundColor = "#F9F9F9";
                    else
                        args.style.backgroundColor = "#28B1BF";
                }
            }
        }
        else if (prop == "lock") {
            if (enter) {
                if (this.lock != null)
                    args.style.backgroundColor = "#E2E2E2";
            }
            else {
                if (this.lock != null) {
                    if (!this.lock)
                        args.style.backgroundColor = "#F9F9F9";
                    else
                        args.style.backgroundColor = "#28B1BF";
                }
            }
        }
        else if (prop == "lineColor") {
            if (enter) {
                if (this.lineColor != "#DDDBDB") {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.lineColor != "#DDDBDB" && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "line") {
            if (enter) {
                if (this.line != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.line != null && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "lineWidth") {
            if (enter) {
                if (this.lineWidth != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.lineWidth != null && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "lineStyle") {
            if (enter) {
                args.style.backgroundColor = "#E2E2E2";
            }
            else {
                if (!this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "headDecorator") {
            if (enter) {
                if (this.headDecorator != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.headDecorator != null && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "tailDecorator") {
            if (enter) {
                if (this.tailDecorator != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.tailDecorator != null && !this.dropdownOpened) {
                    args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "fontColor") {
            if (this.label) {
                if (enter) {
                    if (this.labelfontColor != "#DDDBDB") {
                        args.style.backgroundColor = "#E2E2E2";
                    }
                    else {
                        // Disable state 
                    }
                }
                else {
                    if (this.labelfontColor != "#DDDBDB" && !this.dropdownOpened) {
                        args.style.backgroundColor = "#F9F9F9";
                    }
                }
            }

        }
        else if (prop == "bold") {
            if (enter) {
                if (this.bold != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.bold != null) {
                    if (this.bold == true) {
                        args.style.backgroundColor = "#28B1BF";
                    }
                    else
                        args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "italic") {
            if (enter) {
                if (this.italic != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.italic != null) {
                    if (this.italic == true) {
                        args.style.backgroundColor = "#28B1BF";
                    }
                    else
                        args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "alignTextLeft") {
            if (enter) {
                if (this.textLeftAlign != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.textLeftAlign != null) {
                    if (this.textLeftAlign == true) {
                        args.style.backgroundColor = "#28B1BF";
                    }
                    else
                        args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "alignTextRight") {
            if (enter) {
                if (this.textRightAlign != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.textRightAlign != null) {
                    if (this.textRightAlign == true) {
                        args.style.backgroundColor = "#28B1BF";
                    }
                    else
                        args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
        else if (prop == "alignTextCenter") {
            if (enter) {
                if (this.textCenterAlign != null) {
                    args.style.backgroundColor = "#E2E2E2";
                }
            }
            else {
                if (this.textCenterAlign != null) {
                    if (this.textCenterAlign == true) {
                        args.style.backgroundColor = "#28B1BF";
                    }
                    else
                        args.style.backgroundColor = "#F9F9F9";
                }
            }
        }
    }

    SelectorVMClass.prototype.setTabIconColor = function (args, tab) {
        // 
        if (this.init > 0) {
            if (args.activeIndex == 1) {
                this.tabnodeicon = "#1E989E";
                this.tabPinIcon = "#494949";
                this.tabTextIcon = "#494949";
                this.tabConnectorIcon = "#494949";
            } else if (args.activeIndex == 2) {
                this.tabTextIcon = "#1E989E";
                this.tabPinIcon = "#494949";
                this.tabnodeicon = "#494949";
                this.tabConnectorIcon = "#494949";
            } else if (args.activeIndex == 3) {
                this.tabConnectorIcon = "#1E989E";
                this.tabPinIcon = "#494949";
                this.tabnodeicon = "#494949";
                this.tabTextIcon = "#494949";
            } else if (args.activeIndex == 0) {
                if (this.pinned) {
                    this.pinned = false;
                    var ele = document.getElementById("pinspan");
                    ele.className = 'icon-PH__TabBin';
                    $("#tabitems").ejTab(
                    {
                        selectedItemIndex: args.prevActiveIndex,
                    });
                } else {

                    this.pinned = true;
                    var ele = document.getElementById("pinspan");
                    ele.className = 'icon-PH__TabBin1';
                    $('.icon-PH__TabBin1').css('font-size', '20px');
                    $("#tabitems").ejTab({
                        selectedItemIndex: args.prevActiveIndex,
                    });
                }
            }
        }
        this.init++;
        return this;
    }

    SelectorVMClass.prototype.setPopupDivColor = function (args, model, opened) {
        //  
        if (opened) {
            model.dropdownOpened = true;
        }
        else {
            model.dropdownOpened = false;
        }

    }

    SelectorVMClass.prototype.getNewGradient = function (value) {
        var gradient = {
            type: "linear", x1: 0, x2: 21, y1: -50, y2: 115, stops: [
            { color: "white", offset: -200 }, { color: value, offset: 230 }]
        };
        return gradient;
    };

    SelectorVMClass.prototype.nullgetNewGradient = function () {
        var gradient = {
            type: "radial", cx: 50, cy: 50, fx: 20, fy: 25, r: 50, stops: [
            { color: "white", offset: 0 }, { color: value, offset: 230 }]
        };
        return gradient;
    };


    SelectorVMClass.prototype.openpropertyEditor = function (enable) {
        if (enable) {
            $("#propertyEditor").fadeIn("slow", function () {
            });
        }
        else {
            $("#propertyEditor").fadeOut("slow", function () {
            });
        }
    }

    return SelectorVMClass;
})();







